package cokr.xit.fims.excl.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.excl.LevyExcl;
import cokr.xit.fims.sndb.SndngDtl;
import cokr.xit.fims.crdn.Crdn;
import cokr.xit.fims.cvlc.CrdnCvlcpt;
import cokr.xit.fims.excl.ExclQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 부과제외 대장 정보 DAO
 *
 * <p>상세 설명: 부과제외 대장 테이블에 접근하여 데이터를 조회하고 저장한다.
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-06-23	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("levyExclMapper")
public interface LevyExclMapper extends AbstractMapper {

	/**지정한 조건에 따라 부과제외 대장 목록을 조회하여 반환한다.<br />
	 * @param req 부과제외 대장 조회 조건
	 * @return 부과제외 대장 목록
	 */
	List<DataObject> selectLevyExclList(ExclQuery req);

	/**지정한 조건에 따라 부과제외 대장 객체들을 반환한다.
	 * @param req 부과제외 조회 조건
	 * @return 부과제외 대장 객체 목록
	 */
	List<DataObject> selectLevyExcls(ExclQuery req);

	/**지정한 조건에 따라 부과제외 대장 객체의 마지막 1개를 반환한다.
	 * @param levyExclId 부과제외 ID
	 * @return 부과제외 대장 객체
	 */
	default DataObject selectLevyExclInfo(ExclQuery req) {
		List<DataObject> levyExcls = selectLevyExcls(req);

		return !levyExcls.isEmpty() ? levyExcls.get(0) : null;
	}

	/**부과제외 대장 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"excl01" - 부과 제외 대장</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertLevyExcl(Map<String, Object> params);

	/**부과제외 대장 정보를 등록한다.
	 * @param excl01 부과 제외 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(LevyExcl levyExcl) {
		return levyExcl != null && insertLevyExcl(params().set("levyExcl", levyExcl)) == 1;
	}

	/**부과제외 대장 정보를 수정한다.
	 * @param excl 부과제외 대장
	 * @return 저장된 정보수
	 */
	int updateLevyExcl(Map<String, Object> params);

	default boolean update(LevyExcl levyExcl) {
		return levyExcl != null && updateLevyExcl(params().set("levyExcl", levyExcl)) == 1;
	}

	/**부과제외 대장 정보를 삭제한다.
	 * @param levyExcl 부과제외 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	int deleteLevyExcl(Map<String, Object> params);

	default boolean delete(LevyExcl levyExcl) {
		return levyExcl != null && deleteLevyExcl(params().set("levyExcl", levyExcl)) == 1;
	}

	/**지정한 단속 ID의 단속, 부과제외 정보를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속, 부과제외 정보
	 */
	DataObject selectCrdn(ExclQuery req);

	default DataObject selectCrdnInfo(String crdnId) {
		DataObject crdnInfo = selectCrdn(new ExclQuery().setCrdnId(crdnId));

		return crdnInfo;
	}

	/**지정한 조건에 따라 민원답변문구 대장을 조회하여 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속, 부과제외 정보
	 */
	DataObject selectCvlcptAnsWords(ExclQuery req);

	default DataObject selectCvlcptAnsWordsInfo(String ansRsnCd) {
		DataObject cvlcptAnsWordsInfo = selectCvlcptAnsWords(new ExclQuery().setAnsRsnCd(ansRsnCd));

		return cvlcptAnsWordsInfo;
	}

	/**단속민원(TB_CRDN_CVLCPT) 대장의 민원처리결과내용(CVLCPT_PRCS_RSLT_CN)을 초기화 한다.
	 * @param excl 부과제외 대장
	 * @return 저장된 정보수
	 */
	int updateCvlcptPrcsRsltCn(Map<String, Object> params);

	default boolean updateCvlcptPrcsRsltCn(CrdnCvlcpt crdnCvlcpt) {
		return crdnCvlcpt != null && updateCvlcptPrcsRsltCn(params().set("crdnCvlcpt", crdnCvlcpt)) == 1;
	}

	/**단속민원(TB_CRDN_CVLCPT) 대장의 민원답변 정보를 초기화 한다.
	 * @param excl 부과제외 대장
	 * @return 저장된 정보수
	 */
	int updateCrdnCvlcpt(Map<String, Object> params);

	default boolean updateCrdnCvlcpt(CrdnCvlcpt crdnCvlcpt) {
		return crdnCvlcpt != null && updateCrdnCvlcpt(params().set("crdnCvlcpt", crdnCvlcpt)) == 1;
	}

	/**단속(TB_CRDN) 대장의 주차가능결과코드를 수정 한다.
	 * @param excl 부과제외 대장
	 * @return 저장된 정보수
	 */
	int updateParkngPsbltyRsltCd(Map<String, Object> params);

	default boolean updateParkngPsbltyRsltCd(Crdn crdn) {
		return crdn != null && updateParkngPsbltyRsltCd(params().set("crdn", crdn)) == 1;
	}

	/**지정한 조건에 따라 발송상세 대장을 조회하여 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속, 부과제외 정보
	 */
	DataObject selectSndngDtl(ExclQuery req);

	default DataObject selectSndngDtlInfo(String crdnId, String sndngRcvmtCd) {
		DataObject sndngDtlInfo = selectSndngDtl(new ExclQuery().setCrdnId(crdnId)
																	.setSndngRcvmtCd(sndngRcvmtCd));

		return sndngDtlInfo;
	}

	/**발송 상세(TB_SNDNG_DTL) 대장 수납코드를 수정 한다.
	 * @param excl 부과제외 대장
	 * @return 저장된 정보수
	 */
	int updateRcvmtCd(Map<String, Object> params);

	default boolean updateRcvmtCd(SndngDtl sndngDtl) {
		return sndngDtl != null && updateRcvmtCd(params().set("sndngDtl", sndngDtl)) >= 1;
	}

}
